<template>
  <AppAbstractPage :breadcrumbs="$options.breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        Восстановление пароля
      </h1>
    </div>

    <div
      slot="content"
      class="usersRecoverPassword">
      <template v-if="valid">
        <form
          class="usersRecoverPassword-form"
          v-if="!sended"
          @submit.prevent="send">
          <div class="usersRecoverPassword-form-state">
            <span
              class="input-message-error"
              v-show="error">
              {{ error }}
            </span>
          </div>
          <div class="usersRecoverPassword-form-field">
            <div class="input">
              <input
                v-model="password"
                class="input-field"
                type="password"
                minlength="6"
                name="password"
                placeholder="Введите новый пароль">
            </div>
          </div>
          <div class="usersRecoverPassword-form-field">
            <div class="input">
              <input
                v-model="passwordConfirm"
                class="input-field"
                type="password"
                minlength="6"
                name="passwordConfirm"
                placeholder="Повторите новый пароль">
            </div>
          </div>
          <div class="usersRecoverPassword-form-options">
            <AppButton
              type="submit"
              :disabled="!password || !passwordConfirm || Boolean(error)">
              <span
                slot="button-item"
                class="button-item">
                Сохранить
              </span>
            </AppButton>
          </div>
        </form>
        <div
          v-else
          class="ui form">
          <h2>Пароль изменен</h2>
          <p>
            Если вы считаете, что кто-то знает ваш старый пароль,
            выполните выход из аккаунта на всех других устройствах.
            Также проверьте недавние изменения в своем аккаунте.
          </p>
          <div
            v-if="!auth"
            class="field buttons block">
            <div class="outer line button">
              <div class="inner">
                <AppButton @click.native="showAuthModal">
                  <span
                    slot="button-item"
                    class="button-item">
                    Вход в систему
                  </span>
                </AppButton>
              </div>
            </div>
          </div>
        </div>
      </template>
      <p
        class="usersRecoverPassword-info"
        v-else>Некорректная или устаревшая ссылка.</p>
    </div>
  </AppAbstractPage>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
// import { SHOW } from '~/assets/js/store/infoModal/action-types';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppButton from '~/components/redesign/app-buttons/app-button';

// const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'UsersRecoverPassword',
  components: {
    AppAbstractPage,
    AppButton,
  },
  validate({ query }) {
    const { token } = query;

    if (!token || !token.length) {
      return false;
    }

    return true;
  },
  async asyncData({ app, query }) {
    try {
      const { token } = query;
      const { data } = { ...await app.$axios.$get('/_main/user/checkRecoveryToken', { params: { token } }) };
      return { valid: data.success };
    } catch (e) {
      console.error(e);
    }
    return { valid: false };
  },
  data() {
    return {
      sended: false,
      loading: false,
      password: '',
      passwordConfirm: '',
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    error() {
      if (this.password && this.passwordConfirm && this.password !== this.passwordConfirm) {
        return 'Пароли должны совпадать';
      }
      return false;
    },
  },
  head() {
    return {
      title: 'Восстановление пароля на портале Gisauto.ru',
    };
  },
  watch: {
    auth(newVal) {
      if (newVal) {
        this.$router.push('/cabinet/wrench/profile');
      }
    },
  },
  created() {
    this.$options.breadcrumbs = [
      {
        url: '',
        name: 'Восстановление пароля',
      },
    ];
  },
  methods: {
    // ...STORE_INFO_MODAL.mapActions({
    //   showInfoModal: SHOW,
    // }),
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
    async send() {
      try {
        this.loading = true;
        const { data: { success } } = {
          ...await this.$axios.$post('/_main/user/recoverPasswordByToken', {
            token: this.$route.query.token,
            password: this.password,
          }),
        };
        if (!success) {
          throw new Error('api error');
        }
        this.sended = true;
      } catch (e) {
        console.error(e);
        // this.showInfoModal({
        //   text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
        //   buttonVisible: false,
        // });
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="postcss">
  .usersRecoverPassword {
    /*Компенсируем изменения отстутов из-за .usersRecoverPassword-form-state*/
    margin-top: -14px;

    & .usersRecoverPassword-form {
      max-width: 320px;

      & .usersRecoverPassword-form-state {
        /*Чтобы не прыгали филды после появления ошибки*/
        height: 14px;

        & > .input-message-error {
          display: block;
          padding-top: 0;
        }
      }
    }

    & .usersRecoverPassword-form-field {
      padding-bottom: 1rem;
    }

    @media only screen and ( max-width: 980px ) {
      padding: 0 1.25rem 1.25rem 1.25rem;
    }
  }
</style>
